import {fileOpen as $bd2FF$fileOpen} from "browser-fs-access";

function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}
var $9d7e2e90e2c77008$exports = {};

$parcel$export($9d7e2e90e2c77008$exports, "getAnchorElement", () => $9d7e2e90e2c77008$export$ac81f1ba58a5f363);
$parcel$export($9d7e2e90e2c77008$exports, "Tool", () => $9d7e2e90e2c77008$export$724f6b867059ef5f);
$parcel$export($9d7e2e90e2c77008$exports, "FileTool", () => $9d7e2e90e2c77008$export$de3122b2484864a7);

function $9d7e2e90e2c77008$export$ac81f1ba58a5f363() {
    const { anchorNode: anchorNode  } = self.getSelection() || {
    };
    if (anchorNode) return anchorNode.parentElement;
}
class $9d7e2e90e2c77008$export$724f6b867059ef5f {
    get usable() {
        const { command: command  } = this;
        return !command || document.queryCommandSupported(command) || document.queryCommandEnabled(command);
    }
    getActive() {
        const { command: command , tags: tags  } = this;
        if (tags) {
            const box = $9d7e2e90e2c77008$export$ac81f1ba58a5f363();
            return !!box && box.matches(tags.map((tag)=>`${tag}, ${tag} *`
            ).join(', '));
        }
        if (command) return document.queryCommandState(command);
        return false;
    }
    get active() {
        return this.getActive();
    }
    get title() {
        const { name: name , keys: keys , usable: usable  } = this;
        return `${name}${usable ? keys ? `\n(${keys.join(' + ')})` : '' : '\n(not supported)'}`;
    }
    edit(editor, ...data) {
        editor.focus();
        document.execCommand(this.command, null, ...data);
    }
    execute(editor, ...data) {
        var { inputs: $9d7e2e90e2c77008$var$inputs  } = this, values = [];
        if ($9d7e2e90e2c77008$var$inputs) {
            const data = $9d7e2e90e2c77008$var$inputs.map((input)=>self.prompt(input)
            );
            if (!data.filter(Boolean)[0]) return;
            values = data;
        }
        this.edit(editor, ...values);
    }
}
class $9d7e2e90e2c77008$export$de3122b2484864a7 extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    async save(data) {
        return URL.createObjectURL(data);
    }
    codeOf(path) {
        return path;
    }
    async execute(editor) {
        const path = self.confirm('Confirm to upload a file, or cancel to input a path.') ? await this.save(await $bd2FF$fileOpen()) : self.prompt('Path');
        if (path) this.edit(editor, this.codeOf(path));
    }
}


var $98416e7f1af495b0$exports = {};

$parcel$export($98416e7f1af495b0$exports, "BoldTool", () => $98416e7f1af495b0$export$10056a49e3b218eb);
$parcel$export($98416e7f1af495b0$exports, "ItalicTool", () => $98416e7f1af495b0$export$edf99d0f51bacb1e);
$parcel$export($98416e7f1af495b0$exports, "UnderlineTool", () => $98416e7f1af495b0$export$4b6d9c17188960d2);
$parcel$export($98416e7f1af495b0$exports, "StrikeThroughTool", () => $98416e7f1af495b0$export$a35bffaeae8fdda0);
$parcel$export($98416e7f1af495b0$exports, "H1Tool", () => $98416e7f1af495b0$export$30e8c6b428f8749f);
$parcel$export($98416e7f1af495b0$exports, "H2Tool", () => $98416e7f1af495b0$export$58443375efa91029);
$parcel$export($98416e7f1af495b0$exports, "H3Tool", () => $98416e7f1af495b0$export$75d24d6b8b747307);
$parcel$export($98416e7f1af495b0$exports, "FontSizeDownTool", () => $98416e7f1af495b0$export$a20806c6ef6938f8);
$parcel$export($98416e7f1af495b0$exports, "FontSizeUpTool", () => $98416e7f1af495b0$export$744da7e24e4a7382);
$parcel$export($98416e7f1af495b0$exports, "SubscriptTool", () => $98416e7f1af495b0$export$6137518b4e998008);
$parcel$export($98416e7f1af495b0$exports, "SuperscriptTool", () => $98416e7f1af495b0$export$7217f06c61ebd4fc);
$parcel$export($98416e7f1af495b0$exports, "LinkTool", () => $98416e7f1af495b0$export$f6c54364b5332e66);

class $98416e7f1af495b0$export$10056a49e3b218eb extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    constructor(...args){
        super(...args);
        this.name = 'Bold';
        this.tags = [
            'b',
            'strong'
        ];
        this.keys = [
            'Ctrl',
            'B'
        ];
        this.command = 'bold';
    }
}
class $98416e7f1af495b0$export$edf99d0f51bacb1e extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    constructor(...args){
        super(...args);
        this.name = 'Italic';
        this.tags = [
            'i',
            'em'
        ];
        this.keys = [
            'Ctrl',
            'I'
        ];
        this.command = 'italic';
    }
}
class $98416e7f1af495b0$export$4b6d9c17188960d2 extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    constructor(...args){
        super(...args);
        this.name = 'Underline';
        this.tags = [
            'u'
        ];
        this.keys = [
            'Ctrl',
            'U'
        ];
        this.command = 'underline';
    }
}
class $98416e7f1af495b0$export$a35bffaeae8fdda0 extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    constructor(...args){
        super(...args);
        this.name = 'Strike through';
        this.tags = [
            's',
            'del',
            'strike'
        ];
        this.command = 'strikeThrough';
    }
}
const $98416e7f1af495b0$var$HeadingCommand = document.queryCommandSupported('heading') ? 'heading' : 'formatBlock';
class $98416e7f1af495b0$export$30e8c6b428f8749f extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    execute(editor) {
        this.edit(editor, 'H1');
    }
    constructor(...args){
        super(...args);
        this.name = 'H1';
        this.tags = [
            'h1'
        ];
        this.command = $98416e7f1af495b0$var$HeadingCommand;
    }
}
class $98416e7f1af495b0$export$58443375efa91029 extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    execute(editor) {
        this.edit(editor, 'H2');
    }
    constructor(...args){
        super(...args);
        this.name = 'H2';
        this.tags = [
            'h2'
        ];
        this.command = $98416e7f1af495b0$var$HeadingCommand;
    }
}
class $98416e7f1af495b0$export$75d24d6b8b747307 extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    execute(editor) {
        this.edit(editor, 'H3');
    }
    constructor(...args){
        super(...args);
        this.name = 'H3';
        this.tags = [
            'h3'
        ];
        this.command = $98416e7f1af495b0$var$HeadingCommand;
    }
}
class $98416e7f1af495b0$export$a20806c6ef6938f8 extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    constructor(...args){
        super(...args);
        this.name = 'Font Size down';
        this.tags = [
            'small'
        ];
        this.command = 'decreaseFontSize';
    }
}
class $98416e7f1af495b0$export$744da7e24e4a7382 extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    constructor(...args){
        super(...args);
        this.name = 'Font Size up';
        this.tags = [
            'big'
        ];
        this.command = 'increaseFontSize';
    }
}
class $98416e7f1af495b0$export$6137518b4e998008 extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    constructor(...args){
        super(...args);
        this.name = 'Subscript';
        this.tags = [
            'sub'
        ];
        this.command = 'subscript';
    }
}
class $98416e7f1af495b0$export$7217f06c61ebd4fc extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    constructor(...args){
        super(...args);
        this.name = 'Superscript';
        this.tags = [
            'sup'
        ];
        this.command = 'superscript';
    }
}
class $98416e7f1af495b0$export$f6c54364b5332e66 extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    constructor(...args){
        super(...args);
        this.name = 'Link';
        this.tags = [
            'a'
        ];
        this.inputs = [
            'Path'
        ];
        this.command = 'createLink';
    }
}


var $757e2986efe7b76f$exports = {};

$parcel$export($757e2986efe7b76f$exports, "ColorTool", () => $757e2986efe7b76f$export$ba9bbe5370f1bf2f);
$parcel$export($757e2986efe7b76f$exports, "ForeColorTool", () => $757e2986efe7b76f$export$cab0e15cfb8489d7);
$parcel$export($757e2986efe7b76f$exports, "BackColorTool", () => $757e2986efe7b76f$export$92bb6183e7459be2);

class $757e2986efe7b76f$export$ba9bbe5370f1bf2f extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    getColor() {
        const box = $9d7e2e90e2c77008$export$ac81f1ba58a5f363(), { colorName: colorName  } = this;
        if (!box) return colorName === 'color' ? '#000000' : '#ffffff';
        const { [colorName]: color  } = getComputedStyle(box);
        const [red, green, blue] = color.match(/\d+/g);
        return '#' + (+red).toString(16).padStart(2, '0') + (+green).toString(16).padStart(2, '0') + (+blue).toString(16).padStart(2, '0');
    }
    get active() {
        return !!this.getColor();
    }
    execute(editor, color) {
        this.edit(editor, color);
    }
}
class $757e2986efe7b76f$export$cab0e15cfb8489d7 extends $757e2986efe7b76f$export$ba9bbe5370f1bf2f {
    constructor(...args){
        super(...args);
        this.name = 'Fore Color';
        this.command = 'foreColor';
        this.colorName = 'color';
    }
}
class $757e2986efe7b76f$export$92bb6183e7459be2 extends $757e2986efe7b76f$export$ba9bbe5370f1bf2f {
    constructor(...args){
        super(...args);
        this.name = 'Back Color';
        this.command = 'backColor';
        this.colorName = 'backgroundColor';
    }
}


var $6f103232c7e7dcd7$exports = {};

$parcel$export($6f103232c7e7dcd7$exports, "AlignTool", () => $6f103232c7e7dcd7$export$6c1211091eb3b68f);
$parcel$export($6f103232c7e7dcd7$exports, "AlignLeftTool", () => $6f103232c7e7dcd7$export$42a444ebfdcfe7b9);
$parcel$export($6f103232c7e7dcd7$exports, "AlignCenterTool", () => $6f103232c7e7dcd7$export$9a2e6e0294a984eb);
$parcel$export($6f103232c7e7dcd7$exports, "AlignRightTool", () => $6f103232c7e7dcd7$export$22363f91860fc258);
$parcel$export($6f103232c7e7dcd7$exports, "AlignFullTool", () => $6f103232c7e7dcd7$export$42827b1362fed748);
$parcel$export($6f103232c7e7dcd7$exports, "OrderedListTool", () => $6f103232c7e7dcd7$export$faf4e70f09f43a15);
$parcel$export($6f103232c7e7dcd7$exports, "UnorderedListTool", () => $6f103232c7e7dcd7$export$cf4030b57a3fbe37);
$parcel$export($6f103232c7e7dcd7$exports, "HorizontalRuleTool", () => $6f103232c7e7dcd7$export$dce8a7d6279fc201);

class $6f103232c7e7dcd7$export$6c1211091eb3b68f extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    get active() {
        if (super.getActive()) return true;
        const box = $9d7e2e90e2c77008$export$ac81f1ba58a5f363();
        return !!box && getComputedStyle(box).textAlign === this.align;
    }
}
class $6f103232c7e7dcd7$export$42a444ebfdcfe7b9 extends $6f103232c7e7dcd7$export$6c1211091eb3b68f {
    constructor(...args){
        super(...args);
        this.name = 'Align Left';
        this.command = 'justifyLeft';
        this.align = 'left';
    }
}
class $6f103232c7e7dcd7$export$9a2e6e0294a984eb extends $6f103232c7e7dcd7$export$6c1211091eb3b68f {
    constructor(...args){
        super(...args);
        this.name = 'Align Center';
        this.command = 'justifyCenter';
        this.align = 'center';
    }
}
class $6f103232c7e7dcd7$export$22363f91860fc258 extends $6f103232c7e7dcd7$export$6c1211091eb3b68f {
    constructor(...args){
        super(...args);
        this.name = 'Align Right';
        this.command = 'justifyRight';
        this.align = 'right';
    }
}
class $6f103232c7e7dcd7$export$42827b1362fed748 extends $6f103232c7e7dcd7$export$6c1211091eb3b68f {
    constructor(...args){
        super(...args);
        this.name = 'Align Full';
        this.command = 'justifyFull';
        this.align = 'justify';
    }
}
class $6f103232c7e7dcd7$export$faf4e70f09f43a15 extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    constructor(...args){
        super(...args);
        this.name = 'Ordered list';
        this.tags = [
            'ol'
        ];
        this.command = 'insertOrderedList';
    }
}
class $6f103232c7e7dcd7$export$cf4030b57a3fbe37 extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    constructor(...args){
        super(...args);
        this.name = 'Unordered list';
        this.tags = [
            'ul'
        ];
        this.command = 'insertUnorderedList';
    }
}
class $6f103232c7e7dcd7$export$dce8a7d6279fc201 extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    constructor(...args){
        super(...args);
        this.name = 'Horizontal rule';
        this.tags = [
            'hr'
        ];
        this.command = 'insertHorizontalRule';
    }
}


var $e2652caf0ae68107$exports = {};

$parcel$export($e2652caf0ae68107$exports, "IFrameTool", () => $e2652caf0ae68107$export$3e557574863db086);
$parcel$export($e2652caf0ae68107$exports, "ImageTool", () => $e2652caf0ae68107$export$982f47444a2f88da);
$parcel$export($e2652caf0ae68107$exports, "AudioTool", () => $e2652caf0ae68107$export$6024938f37e646f8);
$parcel$export($e2652caf0ae68107$exports, "VideoTool", () => $e2652caf0ae68107$export$932111b8028f79ed);

class $e2652caf0ae68107$export$3e557574863db086 extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    execute(editor) {
        const path = self.prompt('Path');
        if (path) this.edit(editor, `<iframe style="width: 100%; height: 50vh; border: none" src="${path}"></iframe>`);
    }
    constructor(...args){
        super(...args);
        this.name = 'Embed Web page';
        this.tags = [
            'iframe'
        ];
        this.command = 'insertHTML';
    }
}
class $e2652caf0ae68107$export$982f47444a2f88da extends $9d7e2e90e2c77008$export$de3122b2484864a7 {
    constructor(...args){
        super(...args);
        this.name = 'Image';
        this.tags = [
            'img'
        ];
        this.command = 'insertImage';
    }
}
class $e2652caf0ae68107$export$6024938f37e646f8 extends $9d7e2e90e2c77008$export$de3122b2484864a7 {
    codeOf(path) {
        return `<audio controls src="${path}"></audio>`;
    }
    constructor(...args){
        super(...args);
        this.name = 'Audio';
        this.tags = [
            'audio'
        ];
        this.command = 'insertHTML';
    }
}
class $e2652caf0ae68107$export$932111b8028f79ed extends $9d7e2e90e2c77008$export$de3122b2484864a7 {
    codeOf(path) {
        return `<video controls src="${path}"></video>`;
    }
    constructor(...args){
        super(...args);
        this.name = 'Video';
        this.tags = [
            'video'
        ];
        this.command = 'insertHTML';
    }
}


var $5375dac19c6f93ba$exports = {};

$parcel$export($5375dac19c6f93ba$exports, "UndoTool", () => $5375dac19c6f93ba$export$65235875731ff287);
$parcel$export($5375dac19c6f93ba$exports, "RedoTool", () => $5375dac19c6f93ba$export$b60f30d254d1e1a6);
$parcel$export($5375dac19c6f93ba$exports, "ResetTool", () => $5375dac19c6f93ba$export$6f46dc3d81fbb4bd);
$parcel$export($5375dac19c6f93ba$exports, "ClearTool", () => $5375dac19c6f93ba$export$25eb377ce1feaada);

class $5375dac19c6f93ba$export$65235875731ff287 extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    constructor(...args){
        super(...args);
        this.name = 'Undo';
        this.command = 'undo';
    }
}
class $5375dac19c6f93ba$export$b60f30d254d1e1a6 extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    constructor(...args){
        super(...args);
        this.name = 'Redo';
        this.command = 'redo';
    }
}
class $5375dac19c6f93ba$export$6f46dc3d81fbb4bd extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    constructor(...args){
        super(...args);
        this.name = 'Reset';
        this.command = 'removeFormat';
    }
}
class $5375dac19c6f93ba$export$25eb377ce1feaada extends $9d7e2e90e2c77008$export$724f6b867059ef5f {
    execute(editor) {
        editor.focus();
        document.execCommand('selectAll');
        document.execCommand('delete');
    }
    constructor(...args){
        super(...args);
        this.name = 'Clear';
    }
}




export {$9d7e2e90e2c77008$export$ac81f1ba58a5f363 as getAnchorElement, $9d7e2e90e2c77008$export$724f6b867059ef5f as Tool, $9d7e2e90e2c77008$export$de3122b2484864a7 as FileTool, $98416e7f1af495b0$export$10056a49e3b218eb as BoldTool, $98416e7f1af495b0$export$edf99d0f51bacb1e as ItalicTool, $98416e7f1af495b0$export$4b6d9c17188960d2 as UnderlineTool, $98416e7f1af495b0$export$a35bffaeae8fdda0 as StrikeThroughTool, $98416e7f1af495b0$export$30e8c6b428f8749f as H1Tool, $98416e7f1af495b0$export$58443375efa91029 as H2Tool, $98416e7f1af495b0$export$75d24d6b8b747307 as H3Tool, $98416e7f1af495b0$export$a20806c6ef6938f8 as FontSizeDownTool, $98416e7f1af495b0$export$744da7e24e4a7382 as FontSizeUpTool, $98416e7f1af495b0$export$6137518b4e998008 as SubscriptTool, $98416e7f1af495b0$export$7217f06c61ebd4fc as SuperscriptTool, $98416e7f1af495b0$export$f6c54364b5332e66 as LinkTool, $757e2986efe7b76f$export$ba9bbe5370f1bf2f as ColorTool, $757e2986efe7b76f$export$cab0e15cfb8489d7 as ForeColorTool, $757e2986efe7b76f$export$92bb6183e7459be2 as BackColorTool, $6f103232c7e7dcd7$export$6c1211091eb3b68f as AlignTool, $6f103232c7e7dcd7$export$42a444ebfdcfe7b9 as AlignLeftTool, $6f103232c7e7dcd7$export$9a2e6e0294a984eb as AlignCenterTool, $6f103232c7e7dcd7$export$22363f91860fc258 as AlignRightTool, $6f103232c7e7dcd7$export$42827b1362fed748 as AlignFullTool, $6f103232c7e7dcd7$export$faf4e70f09f43a15 as OrderedListTool, $6f103232c7e7dcd7$export$cf4030b57a3fbe37 as UnorderedListTool, $6f103232c7e7dcd7$export$dce8a7d6279fc201 as HorizontalRuleTool, $e2652caf0ae68107$export$3e557574863db086 as IFrameTool, $e2652caf0ae68107$export$982f47444a2f88da as ImageTool, $e2652caf0ae68107$export$6024938f37e646f8 as AudioTool, $e2652caf0ae68107$export$932111b8028f79ed as VideoTool, $5375dac19c6f93ba$export$65235875731ff287 as UndoTool, $5375dac19c6f93ba$export$b60f30d254d1e1a6 as RedoTool, $5375dac19c6f93ba$export$6f46dc3d81fbb4bd as ResetTool, $5375dac19c6f93ba$export$25eb377ce1feaada as ClearTool};
//# sourceMappingURL=index.js.map
